<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'SlpTooltip',
  props: {
    text: {
      type: String,
      required: false,
      default: '',
    },
    list: {
      type: Array,
      required: false,
      default: () => [],
    },
    position: {
      type: String,
      required: false,
      default: 'bottom',
    },
    mode: {
      type: String,
      required: false,
      default: 'hover',
    },
    // Used for the click mode to prevent opening multiple tooltips at the same time
    id: {
      type: String,
      required: false,
      default: '',
    },
    dataProperties: {
      type: Object,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      open: false,
      linkText: '',
      linkUrl: '',
      regularText: '',
    };
  },
  mounted() {
    if (this.mode === 'click') {
      document.addEventListener('click', this.closeTooltip);
    }
    if (this.text) {
      [, this.linkText] = this.text.match(/\[(.*?)\]/) ?? [];
      [, this.linkUrl] = this.text.match(/\((.*?)\)/) ?? [];

      this.regularText = this.text
        .replace(`(${this.linkUrl})`, '')
        .replace(`[${this.linkText}]`, '')
        .trim();
    }
  },
  beforeDestroy() {
    document.removeEventListener('click', this.closeTooltip);
  },
  methods: {
    setHovered(event: Event) {
      if (this.mode !== 'hover') {
        return;
      }
      this.open = event.type === 'mouseenter';
    },
    openTooltip() {
      this.open = this.mode === 'click';
    },
    closeTooltip(event: any) {
      if (event.target?.id !== this.id) {
        this.open = false;
      }
    },
  },
});
</script>

<template>
  <div
    v-if="mode === 'hover'"
    :id="id"
    aria-label="Click to open tooltip with more information."
    :aria-describedby="`${id}-content`"
    class="slp-tooltip"
    @mouseenter="setHovered"
    @mouseleave="setHovered"
    @click="openTooltip"
  >
    <div class="slp-tooltip__wrapper">
      <slot />
      <div
        v-if="open"
        class="slp-tooltip__content"
        :class="`${position} ${mode === 'hover' ? 'hover-mode' : ''}`"
      >
        {{ regularText }}
        <a
          v-if="text"
          :id="`${id}-content`"
          :data-ga-features="dataProperties?.features?.toLowerCase() ?? null"
          :data-ga-features-sub="dataProperties ? dataProperties.sub : null"
          :data-ga-features-sub-card="
            dataProperties ? dataProperties.card : null
          "
          :data-ga-name="dataProperties ? dataProperties.plan : null"
          :data-ga-location="dataProperties ? 'features content' : null"
          role="tooltip"
          :href="linkUrl"
        >
          {{ linkText }}
        </a>
        <ul
          v-else
          :id="`${id}-content`"
          role="tooltip"
          class="slp-tooltip__list"
        >
          <li v-for="item in list" :key="item.text">
            {{ item.text }}
          </li>
        </ul>
      </div>
    </div>
  </div>
  <button
    v-else
    :id="id"
    aria-label="Click to open tooltip with more information."
    :aria-describedby="`${id}-content`"
    class="slp-tooltip"
    @click="openTooltip"
  >
    <div class="slp-tooltip__wrapper">
      <slot />
      <div
        v-if="open"
        class="slp-tooltip__content"
        :class="`${position} ${mode === 'hover' ? 'hover-mode' : ''}`"
      >
        <span
          v-if="text"
          :id="`${id}-content`"
          role="tooltip"
          v-html="$md.render(text)"
        ></span>
        <ul
          v-else
          :id="`${id}-content`"
          role="tooltip"
          class="slp-tooltip__list"
        >
          <li v-for="item in list" :key="item.text">
            {{ item.text }}
          </li>
        </ul>
      </div>
    </div>
  </button>
</template>

<style scoped lang="scss">
.slp-tooltip {
  position: relative;
  display: inline-block;
  border-bottom: 1px dashed $color-primary-200;

  &.no-border {
    border: none;
  }

  &:hover &__content {
    opacity: 1;
  }

  &__list {
    list-style: inside disc;
    list-style-position: outside;
    margin-left: $spacing-16;
    li {
      margin-bottom: 8px;
    }
  }

  &__wrapper {
    pointer-events: none;
    text-align: left;
  }

  &__content {
    &.hover-mode {
      opacity: 0;
    }
    position: absolute;
    background: #333;
    color: #fff;
    font-size: 12px;
    line-height: 16px;
    padding: 12px;
    width: 170px;
    border-radius: 4px;
    z-index: 20;
    transform: translateX(-50%);
    transition: all 0.3s ease-in-out;
    &::before {
      content: '';
      display: block;
      width: 0;
      height: 0;
      position: absolute;
      left: -8px;
      top: 50px;
    }
    &.top {
      bottom: 28px;
      left: 0;
      &::before {
        border-left: 8px solid transparent;
        border-bottom: 8px solid transparent;
        border-right: 8px solid transparent;
        border-top: 8px solid #333;
        top: 98%;
        left: 50%;
      }
    }
    &.bottom {
      top: 28px;
      left: 41%;
      &::before {
        border-left: 8px solid transparent;
        border-bottom: 8px solid #333;
        border-right: 8px solid transparent;
        left: 46%;
        top: -8px;
      }
    }
    &.right {
      top: -50px;
      right: -275px;
      &::before {
        border-top: 8px solid transparent;
        border-bottom: 8px solid transparent;
        border-right: 8px solid #333;
        left: -8px;
        top: 50px;
      }
    }

    span:deep a {
      cursor: pointer;
      color: $color-surface-50;
      text-decoration: underline;
      pointer-events: all;
    }
  }
}
</style>
